export declare type AnyType = string | number | boolean | symbol | object | null | undefined;
export declare type ConstructorOf<T> = new (...args: any[]) => T;
export declare type ArrayItemType<T> = T extends (infer U)[] ? U : never;
export declare type IsAny<T, TrueType = true, FalseType = false> = 1 extends (T extends never ? 1 : 0) ? TrueType : FalseType;
export declare type IsInvariant<T, U, TrueType = true, FalseType = false> = [T] extends [U] ? ([U] extends [T] ? TrueType : FalseType) : FalseType;
export declare type IsNever<T, TrueType = true, FalseType = false> = [T] extends [never] ? TrueType : FalseType;
export declare type IsInvariantWithoutAny<T, U, TrueType = true, FalseType = false> = IsAny<T, FalseType, IsAny<U, FalseType, IsInvariant<T, U, TrueType, FalseType>>>;
export declare type IsUndefinedOrNever<T, TrueType = true, FalseType = false> = IsInvariant<T, undefined, TrueType, IsNever<T, TrueType, FalseType>>;
export declare type IsTrue<T extends boolean, TrueType = true, FalseType = false> = IsInvariantWithoutAny<T, true, TrueType, FalseType>;
export declare type FilterUndefinedKeys<T extends object> = {
    [Key in keyof T]: undefined extends T[Key] ? Key : never;
}[keyof T];
export declare type OmitUndefinedKeys<T extends object> = {
    [Key in keyof T]: undefined extends T[Key] ? never : Key;
}[keyof T];
export declare type MakeOptional<T extends object> = Exclude<({
    [Key in OmitUndefinedKeys<T>]: T[Key];
} & {
    [Key in FilterUndefinedKeys<T>]?: T[Key];
}) | undefined, undefined>;
